'From Squeak3.9alpha of 4 July 2005 [latest update: #7051] on 6 August 2006 at 11:28:01 am'!
"Change Set:		Morphic-Puzzle
Date:			6 August 2006
Author:			Edgar J. De Cleene

First 3.9 ready version, Have many improvements and  Jerome help "!

BorderedMorph subclass: #PiezaSelectionMorph
	instanceVariableNames: 'w h'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Puzzle'!

!PiezaSelectionMorph commentStamp: '<historical>' prior: 0!
This class is a adaptacion fron SelectionMorph Class and intended as a visual container of several pieces what fits together .
You could have several groups of pieces on the board.
This  implementation lets you cheat.

self setProperty: #cheat toValue: true!

PolygonMorph subclass: #PuzzleMorph
	instanceVariableNames: 'pen numero viejoCentro slopeClamps misLados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Morphic-Puzzle'!

!PuzzleMorph commentStamp: '<historical>' prior: 0!
This is the 2006 version, what owns a tribute to Jerome.
I only wait his improvment

This  implementation lets you cheat, Squeak way.

self setProperty: #cheat toValue: true

You could take pieces from one PiezaSelectionMorph to another via yellow click

You could do any picture in a puzzle with:

PuzzleMorph foto: yourPict 
PuzzleMorph allPieces


If you are conected to web and my mac is on, you should receive a nice picture of Argentina taked by me (and served by a SqueakLight image of course)
From roughly 09:00 to 23:00 GMT
!

PuzzleMorph class
	instanceVariableNames: 'foto sonido'!
TrashCanMorph subclass: #SmartTrashCanMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SqueakRos'!

!Morph methodsFor: 'geometry' stamp: 'edc 7/10/2006 08:20'!
shift: delta
	
		self position: self position + delta! !


!PiezaSelectionMorph methodsFor: 'initialization' stamp: 'edc 4/30/2003 15:53'!
initialize
	super initialize.
	color _ Color transparent.
	! !

!PiezaSelectionMorph methodsFor: 'submorphs-add/remove' stamp: 'edc 8/2/2006 08:37'!
acomodar
	"acomodar could translate as arrange. This metods should be 
	called when you  
	drop a piece from World to existent PiezaSelectionMorph"
	| oldPosition |
	oldPosition := self position.
	self
		submorphsDo: [:m | 
			m borderColor: Color orange.
			m center: m viejoCentro].
	self newExtent.
	self position: oldPosition.
	(submorphs size = PuzzleMorph cantPiezas) ifTrue:[(SampledSound fromWaveStream: PuzzleMorph sonido ) play]! !

!PiezaSelectionMorph methodsFor: 'submorphs-add/remove' stamp: 'edc 8/23/2004 08:47'!
addMorph: aMorph 

	super addMorph: aMorph.
	self acomodar! !

!PiezaSelectionMorph methodsFor: 'submorphs-add/remove' stamp: 'edc 8/5/2006 16:23'!
couldAdd: aMorph


(self isCheating) | (aMorph isCheating ) ifTrue: [ self addMorph: aMorph.
^true].


self submorphsDo:[:m1 | 
(aMorph bounds intersects: m1 bounds) &

(m1 isNeighboorOf: aMorph)
ifTrue:[self addMorph: aMorph.
	^true
	
	]] .
^false! !

!PiezaSelectionMorph methodsFor: 'submorphs-add/remove' stamp: 'EDC 10/30/2002 08:16'!
newExtent
	| minLeft minTop minRight minBottom oldPositions |
	minLeft _ (submorphs
				collect: [:itm | itm left]) min.
	minTop _ (submorphs
				collect: [:itm | itm top]) min.
	minRight _ (submorphs
				collect: [:itm | itm right]) max.
	minBottom _ (submorphs
				collect: [:itm | itm bottom]) max.
oldPositions _ (submorphs
				collect: [:itm | itm position]) .
	self
		bounds: (Rectangle origin: minLeft @ minTop corner: minRight @ minBottom).
	submorphs with: oldPositions do: [:each :oldP | each position: oldP]! !

!PiezaSelectionMorph methodsFor: 'submorphs-add/remove' stamp: 'edc 7/29/2006 08:48'!
removeAllMorphs
	self submorphsDo: [ :m | self removeMorph: m ].
	self delete.! !

!PiezaSelectionMorph methodsFor: 'submorphs-add/remove' stamp: 'edc 7/29/2006 08:51'!
removeMorph: aMorph

aMorph privateOwner: World.
	aMorph center: (self center x - 100 to: self center x + 100) atRandom @(self center y - 100 to: self center y + 100) atRandom. 
	aMorph borderColor: Color black.
	aMorph comeToFront.! !

!PiezaSelectionMorph methodsFor: 'dropping/grabbing' stamp: 'edc 8/5/2006 16:26'!
justDroppedInto: aMorph event: anEvent 
	"Cheat mode for Squeakers.  
	See what happened if you change (self bounds intersects: m1  
	bounds) & (m1 isNeighboorOf: self)  
	 
	to  
	 
	(m1 isNeighboorOf: self)"
	| l goToOther |
	l := ActiveWorld submorphs
				select: [:each | each class == PuzzleMorph | (each class == self class)
						& (self bounds intersects: each bounds) & (each ~= self)]
				thenCollect: [:any | any].
	l
		ifNotEmpty: [l := l first]
		ifEmpty: [^ self].
		((l isKindOf: PuzzleMorph) and:[  self couldAdd: l])
		 ifFalse:[self position: self formerPosition.
			^self]
		
		ifTrue:[	^self].
		.
			
		
		
	
	((l isKindOf: PiezaSelectionMorph)
			and: [self isCheating])
		ifTrue: [l submorphs
				do: [:m2 | self addMorph: m2]].
		(submorphs size >0) ifTrue:[			
			[ self submorphsSatisfying: [:m1| l submorphsDo: [ :m2 |(m1 isNeighboorOf: m2) ifTrue:[l addMorph: m1.
		goToOther := true]
	ifFalse:[goToOther := false].
	((goToOther = true)  &(submorphs size >0))  ] ] ]whileTrue.
					
					
					
					
					 
			
	(submorphs size >0) ifTrue:[		
	self position: self formerPosition ]]
ifFalse:[ self delete]! !

!PiezaSelectionMorph methodsFor: 'event handling' stamp: 'edc 7/29/2006 11:03'!
handlesMouseDown: evt 
	"Prevent stray clicks from picking up the whole game in MVC."
	^ Smalltalk isMorphic not
		or: [evt yellowButtonPressed]! !

!PiezaSelectionMorph methodsFor: 'event handling' stamp: 'edc 7/29/2006 11:05'!
mouseDown: evt 
	
	evt yellowButtonPressed
		ifFalse: [^ evt hand waitForClicksOrDrag: self event: evt].
		self removeAllMorphs! !

!PiezaSelectionMorph methodsFor: 'accessing' stamp: 'edc 7/31/2006 15:45'!
h
	"Answer the value of h"

	^ h! !

!PiezaSelectionMorph methodsFor: 'accessing' stamp: 'edc 7/31/2006 15:45'!
h: anObject
	"Set the value of h"

	h := anObject! !

!PiezaSelectionMorph methodsFor: 'accessing' stamp: 'edc 7/31/2006 15:45'!
w
	"Answer the value of w"

	^ w! !

!PiezaSelectionMorph methodsFor: 'accessing' stamp: 'edc 7/31/2006 15:45'!
w: anObject
	"Set the value of w"

	w := anObject! !

!PiezaSelectionMorph methodsFor: 'as yet unclassified' stamp: 'edc 8/1/2006 19:04'!
balloonText
	^ (PuzzleMorph cantPiezas - submorphs size ) asString , ' pieces to win'! !

!PiezaSelectionMorph methodsFor: 'testing' stamp: 'edc 8/2/2006 06:33'!
isCheating
| eval |
eval := self valueOfProperty: #cheat ifAbsent:[^false] .
^eval
		! !


!PuzzleMorph methodsFor: 'initialization' stamp: 'edc 8/6/2006 06:32'!
initialize
| |
 

	super 
	initialize.
	misLados := Dictionary new.
	
	misLados
		at: #left
		put: (LineMorph
				from: 0 @ 45
				to: 0 @ 0
				color: Color black
				width: 2).
	misLados
		at: #top
		put: (LineMorph
				from: 0 @ 0
				to: 60 @ 0
				color: Color black
				width: 2).
	misLados
		at: #right
		put: (LineMorph
				from: 60 @ 0
				to: 60 @ 45
				color: Color black
				width: 2).
	misLados
		at: #bottom
		put: (LineMorph
				from: 60 @ 45
				to: 0 @ 45
				color: Color black
				width: 2).
	self perform: #(#peninsula: #golfo: ) atRandom with: #right.
	(misLados at: #right)
		setVertices: (misLados at: #right) vertices reverse.
	self perform: #(#peninsula: #golfo: ) atRandom with: #bottom.
	(misLados at: #bottom)
		setVertices: (misLados at: #bottom) vertices reverse.
		
		
	
	! !

!PuzzleMorph methodsFor: 'accessing' stamp: 'edc 6/20/2006 09:15'!
misLados
^ misLados! !

!PuzzleMorph methodsFor: 'accessing' stamp: 'edc 6/20/2006 09:15'!
misLados: aDictionary
misLados := aDictionary! !

!PuzzleMorph methodsFor: 'accessing' stamp: 'edc 2/6/2006 11:31'!
misVecinos
	

self borderColor = Color red ifTrue: [^0].
	
	misVecinos 
		isEmptyOrNil ifFalse:[ misVecinos  do: [:each | 
			(each bounds intersects: self bounds)
				ifTrue: [	self conQuienMeJuinto: each]]]
					! !

!PuzzleMorph methodsFor: 'accessing' stamp: 'edc 4/27/2003 09:28'!
nextOrigin
^ nextOrigin! !

!PuzzleMorph methodsFor: 'accessing' stamp: 'edc 4/27/2003 09:28'!
nextOrigin: aPoint
	 nextOrigin _ aPoint! !

!PuzzleMorph methodsFor: 'accessing' stamp: 'edc 6/19/2006 08:54'!
numero
^ numero! !

!PuzzleMorph methodsFor: 'accessing' stamp: 'edc 6/20/2006 09:05'!
numero: anInteger
numero:= anInteger! !

!PuzzleMorph methodsFor: 'accessing' stamp: 'edc 5/8/2003 09:47'!
viejoCentro
^ viejoCentro! !

!PuzzleMorph methodsFor: 'accessing' stamp: 'edc 5/8/2003 09:47'!
viejoCentro: aPoint
	 viejoCentro _ aPoint! !

!PuzzleMorph methodsFor: 'testing' stamp: 'edc 8/1/2006 15:43'!
conQuienMeJuinto: aMorph
| propietario s |


propietario := aMorph owner.
propietario = ActiveWorld ifTrue:[ s := PiezaSelectionMorph new.
	s position: aMorph position.
											s addMorph: aMorph.
											s addMorph: self.
											
											s openInWorld]
ifFalse: [^propietario addMorph: self.].
! !

!PuzzleMorph methodsFor: 'testing' stamp: 'edc 8/2/2006 06:19'!
isCheating
| eval |
eval := self valueOfProperty: #cheat ifAbsent:[^false] .
^eval
		! !

!PuzzleMorph methodsFor: 'testing' stamp: 'edc 7/31/2006 17:31'!
isNeighboorOf: aMorph
| vecino|
	misLados valuesDo: [:v| vecino :=(v valueOfProperty: #neighboor ifAbsent:[]).
		vecino  ifNotNil:[aMorph misLados valuesDo: [:o|  o = vecino ifTrue:[^true]
		 ]]].
^false! !

!PuzzleMorph methodsFor: 'dropping/grabbing' stamp: 'edc 8/2/2006 10:24'!
justDroppedInto: aMorph event: anEvent 
| l |

l := (ActiveWorld submorphs
select: [:each | (each class == PiezaSelectionMorph) | (each class == self class) &
(self bounds intersects: each bounds) & (each ~= self)]
thenCollect: [:any | any]) .

l ifNotEmpty:[ l := l first]
ifEmpty:[^self].
((l isKindOf: PuzzleMorph) and: [l isNeighboorOf: self]) ifTrue:[ self conQuienMeJuinto: l.
	^self].


(l isKindOf: PiezaSelectionMorph) ifTrue: [l isCheating ifTrue:[^ l addMorph: self].
	l submorphsDo:[:m1 | 
(self bounds intersects: m1 bounds) &

(m1 isNeighboorOf: self)
ifTrue:[^ l addMorph: self]]].
self position: self formerPosition.

! !

!PuzzleMorph methodsFor: 'stepping and presenter' stamp: 'edc 2/2/2006 10:55'!
repel: aMorph
| sides repelTo |
sides := #(left top right bottom).
repelTo := sides atRandom.
self repel: aMorph to: repelTo
! !

!PuzzleMorph methodsFor: 'stepping and presenter' stamp: 'edc 2/2/2006 11:01'!
repel: aMorph to: aSide
aSide = #left ifTrue:[aMorph left: self right - 5 ].
aSide = #right ifTrue:[aMorph right: self left + 5 ].
aSide = #top ifTrue:[aMorph top: self bottom - 5 ].
aSide = #bottom ifTrue:[aMorph bottom: self top + 5 ].! !

!PuzzleMorph methodsFor: 'smoothing' stamp: 'edc 7/11/2006 07:24'!
slopes: knots 
	"Choose slopes according to state of polygon and preferences"
	| myClamps |
	self isCurvy
		ifFalse: [^ knots segmentedSlopes].
	^ (closed
			and: [self isCurvier])
		ifTrue: [myClamps := self clamps .
			(myClamps allSatisfy: [ :e | e == nil ] )
			ifTrue: [ knots closedCubicSlopes ]
			ifFalse: [knots clampedCubicSlopes: myClamps] ]
		ifFalse: [knots clampedNaturalCubicSlopes: self clamps ]! !

!PuzzleMorph methodsFor: 'editing' stamp: 'edc 7/11/2006 07:24'!
clickVertex: ix event: evt fromHandle: handle
" Toggle the state of the clamp. "
"Note: self clamps assures slopeClamps will be same size as vertices"

(self clamps at: ix) 
	ifNil:	 [ slopeClamps  at: ix put: 0 ]
	ifNotNil: [ slopeClamps  at: ix put: nil ] .
	self setVertices: vertices .
	
! !

!PuzzleMorph methodsFor: 'editing' stamp: 'edc 7/11/2006 07:24'!
deleteVertexAt: anIndex
			(slopeClamps :=
						slopeClamps
						copyReplaceFrom: anIndex
						to: anIndex
						with: Array new) .
			self
				setVertices: (vertices
						copyReplaceFrom: anIndex
						to: anIndex
						with: Array new).
						! !

!PuzzleMorph methodsFor: 'editing' stamp: 'edc 7/11/2006 07:24'!
insertVertexAt: anIndex put: aValue
	"New vertexs are unclamped."
	"Note: order is important. 
	The clamps array must match vertex size before setVertices: is performed."
	slopeClamps := slopeClamps 
		copyReplaceFrom: anIndex + 1 to: anIndex with: (Array with: nil).
	self setVertices: (vertices copyReplaceFrom: anIndex + 1 to: anIndex 
									with: (Array with: aValue)).! !

!PuzzleMorph methodsFor: 'access' stamp: 'edc 7/11/2006 07:24'!
clamps
" Return a collection of clamps the same size as vertices.
	If necessary default to unclamped slopes.
"

slopeClamps 
	ifNil:   [ ^ slopeClamps := Array new: vertices size  ] .
slopeClamps size = vertices size
	ifFalse: [ ^ slopeClamps := Array new: vertices size  ] . 
	^ slopeClamps           ! !

!PuzzleMorph methodsFor: 'access' stamp: 'edc 8/6/2006 06:33'!
draw
| newVertices  corners ind  sidesBuildOrder lado fill |
corners := OrderedCollection new.
newVertices := OrderedCollection new.

newVertices  addAll: (misLados at: #left) vertices .
	sidesBuildOrder := #(#top #right #bottom ).
	sidesBuildOrder
		do: [:side | 
			
			lado := ( misLados at: side) vertices.
			lado := lado copyWithoutFirst.
			newVertices addAll: lado.
			].
		self setVertices: newVertices;
		color: Color blue;
		borderWidth: 2;
		borderColor: Color black.
		corners add: (misLados at: #left) vertices first copy.
		corners add: (misLados at: #left) vertices last copy.
		corners add: (misLados at: #right) vertices  first copy.
		corners add: (misLados at: #right) vertices  last copy.
		
		
		
		corners do: [:c|
		ind :=  vertices indexOf: c ifAbsent:[].
		ind ifNotNil:[self clamps at: ind put: 0 ]].
		self clamps atWrap: 0 put: 0 . "clamp the final one that over laps the first."
	self   beSmoothCurve;makeClosed;openInWorld.
	self viejoCentro: self center.
	fill := BitmapFillStyle fromForm: PuzzleMorph foto.
	fill origin: 0@0.
	self fillStyle: fill
		
		

	! !

!PuzzleMorph methodsFor: 'access' stamp: 'edc 7/11/2006 07:24'!
handleColorAt: vertIndex
      " clamped handles are cyan     and 
	unclamped handles are yellow."

(self clamps at: vertIndex ) ifNil: [ ^ Color yellow ] .
^ Color cyan 
! !

!PuzzleMorph methodsFor: 'halos and balloon help' stamp: 'edc 7/29/2006 10:38'!
balloonText
	^ self name! !

!PuzzleMorph methodsFor: 'as yet unclassified' stamp: 'edc 6/19/2006 07:43'!
golfo: aSide
| pen  lado p|


pen := PenPointRecorder new.
pen up.
	pen goto: (misLados at: aSide ) vertices last.
	pen down.
	lado :=  (misLados at: aSide ) .
	(aSide = #bottom) ifTrue:[
	pen turn: 90.
	
	p := (lado vertices first) interpolateTo: (lado vertices last) at: 0.7.
pen go: p.
			pen turn: 270.
			pen go: 15.
			pen turn: 90.
			pen go: 15.
			pen turn: 90.
			pen go: 15.
			pen turn: 270.
			pen goto: (misLados at: aSide ) vertices first].
		(aSide = #right) ifTrue:[p := (lado vertices first) interpolateTo: (lado vertices last) at: 0.3.
			pen go: p.
			pen turn: 270.
			pen go: 11.
			pen turn: 90.
			pen go: 11.
			pen turn: 90.
			pen go: 11.
			pen turn: 270.
			pen goto: (misLados at: aSide ) vertices first
			
			].
			(aSide = #top) ifTrue:[self halt].
		(aSide = #left) ifTrue:[self halt].
		lado := PolygonMorph 
vertices: pen points asArray
		color: Color blue
		borderWidth: 2
		borderColor: Color red.
		lado makeOpen.
		
misLados at: aSide  put: lado
! !

!PuzzleMorph methodsFor: 'as yet unclassified' stamp: 'edc 6/9/2006 08:44'!
peninsula: aSide
| pen  lado p|


pen := PenPointRecorder new.
pen up.
	pen goto: (misLados at: aSide ) vertices last.
	pen down.
	lado :=  (misLados at: aSide ) .
	(aSide = #bottom) ifTrue:[
	pen turn: 90.
	
	p := (lado vertices first) interpolateTo: (lado vertices last) at: 0.7.
pen go: p.
			pen turn: 90.
			pen go: 15.
			pen turn: 270.
			pen go: 15.
			pen turn: 270.
			pen go: 15.
			pen turn: 90.
			pen goto: (misLados at: aSide ) vertices first].
		(aSide = #right) ifTrue:[p := (lado vertices first) interpolateTo: (lado vertices last) at: 0.3.
			pen go: p.
			pen turn: 90.
			pen go: 11.
			pen turn: 270.
			pen go: 11.
			pen turn: 270.
			pen go: 11.
			pen turn: 90.
			pen goto: (misLados at: aSide ) vertices first
			].
		(aSide = #top) ifTrue:[self halt].
		(aSide = #left) ifTrue:[self halt].
		lado := PolygonMorph 
vertices: pen points asArray
		color: Color blue
		borderWidth: 2
		borderColor: Color red.
		lado makeOpen.
		
misLados at: aSide  put: lado


! !

!PuzzleMorph methodsFor: 'event handling' stamp: 'edc 7/31/2006 16:57'!
handlesMouseDown: evt 
	"Prevent stray clicks from picking up the whole game in MVC."
	^ Smalltalk isMorphic not
		or: [evt yellowButtonPressed]! !

!PuzzleMorph methodsFor: 'event handling' stamp: 'edc 7/31/2006 16:59'!
mouseDown: evt 
	
	evt yellowButtonPressed
		ifFalse: [^ evt hand waitForClicksOrDrag: self event: evt].
		evt hand grabMorph: self. "allow repositioning"! !


!PuzzleMorph class methodsFor: 'instance creation' stamp: 'edc 8/5/2006 15:53'!
cantPiezas
"PuzzleMorph cantPiezas"
^(ActiveWorld submorphs
				select: [:each | each class == PuzzleMorph ]
				thenCollect: [:any | any]) size
	! !

!PuzzleMorph class methodsFor: 'instance creation' stamp: 'edc 8/6/2006 06:28'!
foto
"(SketchMorph withForm: PuzzleMorph foto) openInWorld"
^foto ! !

!PuzzleMorph class methodsFor: 'instance creation' stamp: 'edc 8/6/2006 06:28'!
foto: aPict
foto := aPict! !

!PuzzleMorph class methodsFor: 'instance creation' stamp: 'edc 8/6/2006 06:28'!
sonido
"(SampledSound fromWaveStream: PuzzleMorph sonido ) play  "
^sonido ! !

!PuzzleMorph class methodsFor: 'instance creation' stamp: 'edc 8/6/2006 11:27'!
sonido: aWavFilePath
sonido :=  (RWBinaryOrTextStream with: (aWavFilePath) contentsOfEntireFile )reset.! !

!PuzzleMorph class methodsFor: 'as yet unclassified' stamp: 'edc 7/31/2006 15:55'!
allPieces

" PuzzleMorph allPieces"
| fila1 fila2 sideOld  l  xp n h |
h := (self foto height  // 45)-1 .
xp := 0.
n :=1.
fila1 := self fila0Piece.

fila1 do: [:ea| ea draw.
	
	
	ea  numero: n.
	n := n + 1].

1 to: h do: [:i| fila2 := self fila0Piece.
fila2 do: [:ea| 
	ea misLados valuesDo: [:k|k shift: (0@45)* i]].
fila1 with: fila2 do: [:f1 :f2| sideOld := (f1 misLados at: #bottom) vertices reverse copy.
		
(f2 misLados at: #top) setVertices: sideOld.
(i = h ) ifTrue:[ l := (LineMorph
				from: 60 @ h-1 *45
				to: 0 @ h +1*45
				color: Color black
				width: 2).
				l shift: (60@0)* (xp).
				xp := xp + 1.
	(f2 misLados) at: #bottom
		put: l].
	(f1 misLados at: #bottom ) setProperty: #neighboor toValue: (f2 misLados at: #top).
	(f2 misLados at: #top) setProperty: #neighboor toValue: (f1 misLados at: #bottom ).
	
f2 draw.
f2  numero: n.

	n := n + 1.
].
.fila1 := fila2 copy].

self desparramar! !

!PuzzleMorph class methodsFor: 'as yet unclassified' stamp: 'edc 7/31/2006 15:29'!
desparramar
| aList  randomCenter |
aList := ActiveWorld submorphs
				select: [:each | each class == PuzzleMorph].
				
			aList do: [  :m| randomCenter :=(50 to: World width - 50) atRandom @(50 to: World height -50) atRandom. 
	m center: randomCenter.
	
	
	
	
	m comeToFront. 
	m show.
	
	m step]! !

!PuzzleMorph class methodsFor: 'as yet unclassified' stamp: 'edc 7/31/2006 11:46'!
fila0Piece
	| piezas sideOld np dict p w |
	w := self foto width  // 60.
	
piezas := OrderedCollection new.
1 to: w do: [:i| p := PuzzleMorph new.
	
	p misLados valuesDo: [:k| k shift: (60@0)* (i - 1) ].
	piezas add: p].	
	
	2 to: w do: [:i|sideOld := ((piezas at: i -1) misLados at: #right) vertices reverse copy.
np := PolygonMorph vertices: sideOld color: Color white borderWidth: 2 borderColor: Color black.
np makeOpen.

dict := (piezas at: i )  misLados.
	dict at: #left put: np copy.
	
	((piezas at: i -1) misLados at: #right) setProperty: #neighboor toValue: ((piezas at: i )  misLados at: #left ).
	((piezas at: i )  misLados at: #left ) setProperty: #neighboor toValue: ((piezas at: i -1) misLados at: #right).
	
	
	
	].
dict := (piezas at: w)  misLados.
dict
		at: #right
		put: (LineMorph
				from: 60 * w @ 0
				to: 60 * w @ 45
				color: Color black
				width: 2).
				
^piezas! !

!PuzzleMorph class methodsFor: 'as yet unclassified' stamp: 'edc 8/6/2006 06:29'!
remotePhoto
|stream |
"This lets play with nice Argentina pictures taked by me

PuzzleMorph remotePhoto"
 HTTPSocket httpGet: 'http://201-212-99-13.cab.prima.net.ar:8084'.
stream := HTTPSocket httpGet: 'http://201-212-99-13.cab.prima.net.ar/MundoEd/last.jpg'.
stream binary.
foto:= Form fromBinaryStream: stream.
self allPieces! !

!PuzzleMorph class methodsFor: 'as yet unclassified' stamp: 'edc 8/6/2006 06:27'!
selectNewPicture
| pathName oldFolder newFolder |
oldFolder := FileDirectory default.
	newFolder := FileList2 modalFolderSelector.
	FileDirectory setDefaultDirectory: newFolder pathName.
	
	
	pathName _ Utilities chooseFileWithSuffixFromList: Utilities graphicsFileSuffixes withCaption: 'Choose a picture
for Puzzle'..
	foto:= Form fromFileNamed: pathName.
	FileDirectory setDefaultDirectory: oldFolder pathName.
	self allPieces! !

!PuzzleMorph class methodsFor: 'as yet unclassified' stamp: 'edc 8/5/2006 15:54'!
toggleFullScreen
	ScreenController lastScreenModeSelected
		ifTrue: [ScreenController new fullScreenOff]
		ifFalse: [ScreenController new fullScreenOn].
	World positionSubmorphs.
! !


!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 7/18/2004 23:12'!
asCubic
	"Convert this point array to a Cubic object"
	self
		assert: [self size = 4].
	self
		assert: [self
				allSatisfy: [:each | each isPoint]].
	^ Cubic withAll: self! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 1/29/2006 16:30'!
assertSlopesClampedWith: knots from: start to: end
   "
	We trust everything has been checked. 
	The following assertions should hold at this point: "
	
	
	self assert: [ self size = knots size ] . 
	"Sizes must be consistent." 
	self assert: [ end > start + 1 ]. 
	"There must be at least one slope to clamp." 
	self assert: [ 0 < start and: [start <= knots size] ]. 
	"The clamped slope may be the last one."
	self assert: [  end  < knots size + start ] . 
	"We can wrap. There may be only one known slope."
	self assert: [ (self at: start ) class  = (self at: end ) class ] . 
	"Slopes must be consistent."
	self assert: [ (self at: start ) isNumber or: [   (self at: start ) isPoint ] ] . 
	"And a known and reasonalble value."
		^true
	! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 2/7/2006 17:22'!
assertSlopesWith: knots from: start to: end
   "
	We trust everything has been checked. 
	The following assertions should hold at this point: "
	
	
	| slope |
	self assert: [ self size = knots size ] . 
	"Sizes must be consistent." 
	self assert: [ end > start]. 
	"There must be at least one slope to clamp." 
	self assert: [ 0 < start and: [start <= knots size] ]. 
	"The clamped slope may be the last one."
	self assert: [  end  <= knots size + start ] . 
	"We can wrap. There may be only one known slope."
	self assert: [ end = knots size + start ifTrue: [ (self at: start) notNil ] ] .
		"If we overlap slope must be known."
	{ start . end } 
		do: [ :index | slope := (self at: index )
	self assert: [ slope isNil 
				or: [ slope isNumber 
				or: [ slope isPoint ] ] ] ] . 
	"And a known and reasonalble value or nil." 
		^true 
	! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 1/30/2005 21:04'!
changeInSlopes: slopes 
	"A message to knots of a spline. Returns an array with the 3rd cubic coeff."
	"The last nth item is correct iff this is a closed cubic.
	Presumably that is the only time we care.
	We always return the same sized array as self."
	| n slopeChanges |
	n := self size.
	n = slopes size
		ifFalse: [^ self error: 'vertices and slopes differ in number'].
	slopeChanges := Array new: n.
	(1 to: n)
		do: [:i | slopeChanges at: i put: (self atWrap: i + 1)
					- (self at: i) * 3 - ((slopes at: i)
						* 2)
					- (slopes atWrap: i + 1)].
	
	^ slopeChanges! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 1/30/2005 21:04'!
changeOfChangesInSlopes: slopes 
	"A message to knots of a spline. Returns an array with the 4rd 
	cubic coeff."
	"The last nth item is correct iff this is a closed cubic. 
	Presumably that is the only time we care. 
	We always return the same sized array as self."
	| n changes |
	n := self size.
	n = slopes size
		ifFalse: [^ self error: 'vertices and slopes differ in number'].
	changes := Array new: n.
	(1 to: n)
		do: [:i | changes at: i put: (self at: i)
					- (self atWrap: i + 1) * 2
					+ (slopes at: i)
					+ (slopes atWrap: i + 1)].
	
	^ changes! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 2/12/2006 23:24'!
clampedCubicSlopes: clampedSlopes
	"Sent to knots returns a copy of clampedSlopes with the values of the undefined (nil)  slopes filled in.
	This is a modification of naturalCubicSlopes 
	"
	" clampedSlopes must be the same size as knots and at least one slope must be clamped (i.e. not nil)" 
	
	"/* Between known slopes we solve the equation for knots with end conditions:  
	4*b1+b2 = 3(a2 - a0) - b0 
	bN2+4*bN1 = 3*(aN-aN2) - bN
	and inbetween:
	b2+4*b3+b4=3*(a4-a2)
	where a2 is (knots atWrap: index + 1) etc.
	and the b's are the slopes .
	N is the last index (knots size)
	N1 is N-1.  
	"
	| slopes  |
	slopes := clampedSlopes copy. "slopes will be modified."
	clampedSlopes closedFillinList do: [ :r | slopes slopesClampedWith: self from: r first to: r last ] .
	
	^ slopes! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 2/8/2006 20:20'!
clampedNaturalCubicSlopes: clampedSlopes
	"Sent to knots returns a copy of clampedSlopes with the values of the undefined (nil)  slopes filled in.
	This is a modification of naturalCubicSlopes 
	"
	" clampedSlopes must be the same size as knots and at least one slope must be clamped (i.e. not nil)" 
	
	"/* Between known slopes we solve the equation for knots with end conditions:  
	4*b1+b2 = 3(a2 - a0) - b0 
	bN2+4*bN1 = 3*(aN-aN2) - bN
	and inbetween:
	b2+4*b3+b4=3*(a4-a2)
	where a2 is (knots atWrap: index + 1) etc.
	and the b's are the slopes .
	N is the last index (knots size)
	N1 is N-1.
	 
	by using row operations to convert the matrix to upper  
	triangular  
	and then back sustitution. The D[i] are the derivatives at the  
	knots.  
	"
	| slopes  |
	slopes := clampedSlopes copy. "slopes will be modified."
	clampedSlopes naturalFillinList do: [ :r | slopes slopesWith: self from: r first to: r last ] .
	
	^ slopes! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 1/30/2005 22:03'!
closedCubicSlopes
	"Sent to knots returns the slopes of a closed cubic spline.
	From the same set of java sources as naturalCubic. This is a squeak  
	transliteration of the java code."
	"from java code NatCubicClosed extends NatCubic  
	solves for the set of equations for all knots: 
	b1+4*b2+b3=3*(a3-a1)
	where a1 is (knots atWrap: index + 1) etc.
	and the b's are the slopes .
	
	by decomposing the matrix into upper triangular and lower matrices  
	and then back sustitution. See Spath 'Spline Algorithms for Curves  
	and Surfaces' pp 19--21. The D[i] are the derivatives at the knots.  
	"
	
	| v w x y z n1  D F G H |
	n1 := self size.
	n1 < 3
		ifTrue: [self error: 'Less than 3 points makes a poor curve'].
	v := Array new: n1.
	w := Array new: n1.
	y := Array new: n1.
	
	D := Array new: n1.
	x := self.
	z := 1.0 / 4.0.
	v at: 2 put: z.
	w at: 2 put: z.
	y at: 1 put: z * 3.0 * ((x at: 2)
				- (x at: n1)).
	H := 4.0.
	F := 3 * ((x at: 1)
					- (x at: n1 - 1)).
	G := 1.
	(2 to: n1 - 1)
		do: [:k | 
			z := 1.0 / (4.0
							- (v at: k)).
			v at: k + 1 put: z.
			w at: k + 1 put: z negated
					* (w at: k).
			y at: k put: z * (3.0 * ((x at: k + 1)
							- (x at: k - 1))
						- (y at: k - 1)).
			H := H - (G
						* (w at: k)).
			F := F - (G
						* (y at: k - 1)).
			G := (v at: k) negated * G].
	H := H - (G + 1 * ((v at: n1)
						+ (w at: n1))).
	y at: n1 put: F - (G + 1
				* (y at: n1 - 1)).
	D at: n1 put: (y at: n1)
			/ H.
	D at: n1 - 1 put: (y at: n1 - 1)
			- ((v at: n1)
					+ (w at: n1)
					* (D at: n1)).
	(1 to: n1 - 2)
		reverseDo: [:k | D at: k put: (y at: k)
					- ((v at: k + 1)
							* (D at: k + 1)) - ((w at: k + 1)
						* (D at: n1))].
^ D .

! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 2/8/2006 00:45'!
closedFillinList
	"Answers a list of ranges between which values are undertermined.
	Reciever is a list that combines known values and nil entries for
	undetermined values.
	Answer a list of ranges. Each range starts and ends with a known
	value. 
	The range inbetween the known values are nil. The ranges start and
	ends may overlap. 
	Each nil element in the list appears in exactly one range. 
	If the list starts or ends with nil the last range will wrap around to the
	next known value. There may be only one known value in the list but
	there must be atleast one know value.
	
	(self allsatisfy: [ :e | e isNil ] ) ifTrue: [ self error: 'list must contain at
	least one known value' ] 
	"
	| changes n |
	changes := self nilTransitions .
	changes isEmpty ifTrue: [ self error: ' At least one value must be known' ] .
	 
	changes = #(1) ifTrue: [ ^ #() "Special case. no unknowns." ] . 
	changes = { n :=  self size } ifTrue: [ ^ { n to: n + n } ] .
	"Special case. Only last element known."
	
	changes size even ifTrue: 
			[changes add: self size
							+ (changes at: 1)]
						ifFalse: [
		changes first = 1 ifFalse: [ changes add: self size + 1;
											add: self size + changes first ]
						
		].
	^ changes allButFirst pairsCollect: [ :s :e | ( s - 1 to: e ) ] .

	! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 7/18/2004 23:18'!
cubicPointPolynomialAt: vIndex
	"From curve information assemble a 4-array of points representing the coefficents for curve segment between to points. Beginning point is first point in array endpoint is the pointSum of the array. Meant to be sent to newcurves idea of curve coefficents." 
	^ ((1 to: 4)
		collect: [:i | ((self at: i)
				at: vIndex)
				@ ((self at: 4 + i)
						at: vIndex)]) asCubic! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 2/12/2006 23:21'!
naturalCubicSlopes
	"Sent to knots returns the slopes of a natural cubic curve fit.
	This is a direct  squeak  
	transliteration of the java code."
	" public class NatCubic extends ControlCurve
	
	/* We solve the equation for knots with end conditions:  
	2*b1+b2 = 3(a1 - a0) 
	bN1+2*bN = 3*(aN-aN1)
	and inbetween:
	b2+4*b3+b4=3*(a4-a2)
	where a2 is (knots atWrap: index + 1) etc.
	and the b's are the slopes .
	N is the last index (knots size)
	N1 is N-1.
	 
	by using row operations to convert the matrix to upper  
	triangular  
	and then back sustitution. The D[i] are the derivatives at the  
	knots.  
	"
	| x gamma delta D n1 |
	n1 := self size.
	n1 < 3
		ifTrue: [self error: 'Less than 3 points makes a poor curve'].
	x := self.
	gamma := Array new: n1.
	delta := Array new: n1.
	
	D := Array new: n1.
	gamma at: 1 put: 1.0 / 2.0.
	(2 to: n1 - 1)
		do: [:i | gamma at: i put: 1.0 / (4.0
						- (gamma at: i - 1))].
	gamma at: n1 put: 1.0 / (2.0
				- (gamma at: n1 - 1)).
	delta at: 1 put: 3.0 * ((x at: 2)
				- (x at: 1))
			* (gamma at: 1).
	(2 to: n1 - 1)
		do: [:i | delta at: i put: 3.0 * ((x at: i + 1)
						- (x at: i - 1))
					- (delta at: i - 1)
					* (gamma at: i)].
	delta at: n1 put: 3.0 * ((x at: n1)
				- (x at: n1 - 1))
			- (delta at: n1 - 1)
			* (gamma at: n1).
	D
		at: n1
		put: (delta at: n1).
	(1 to: n1 - 1)
		reverseDo: [:i | D at: i put: (delta at: i)
					- ((gamma at: i)
							* (D at: i + 1))].
	^ D! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 2/9/2006 00:46'!
naturalFillinList
	"Return a list of fillin ranges to be used to calculate natural or clamped slopes.
	Note that this list is slightly different in mission from the closedFillinList"
	"Answers a list of ranges between which value are undertermined.
	Reciever is a list that combines known values and nil entries for
	undetermined values.
	Answer a list of ranges. Each range starts and ends with a known value. 
	With the exception of the first and last slopes on the list which may be unknown.
	If no slopes are known then the only range is the whole list.
	If all slopes are known then the fillin list is empty.
	The range inbetween the known values are nil. The ranges start and
	ends may overlap if the slope at the overlap is known.
	Each nil element in the list appears in exactly one range.  
	"
	| changes  |
	changes := self nilTransitions .
	changes isEmpty ifTrue: [ ^ { 1 to: self size } "Special case all unknown." ] .
	 
	changes = #(1) ifTrue: [ ^ #() "Special case. no unknowns." ] . 
	
	changes size even 
			ifTrue: [changes add: self size ] .  "Last slope is unknown"
	changes first = 1
			ifTrue: [ ^ changes allButFirst pairsCollect: [ :s :e | (  s - 1 to: e ) ] ] .
	 
		"Otherwise first slope is unknown."
				
						
			^ { 1 to: changes first } , 
					(changes allButFirst pairsCollect: [ :s :e | ( ( s - 1) to: e ) ]) 

	! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 1/29/2006 20:51'!
nilTransitions
	"Return an OrderedCollection of transition indexes.  
	Indexes represent where the list elements transitions 
	from nil to nonNil 
		or from nonNil to nil.
	1 is an index in the list iff the first element is nonNil. "
	
	| changes nilSkip |

	changes := OrderedCollection new.
	nilSkip := true .
	
	(1 to: self size)
		do: [:i | (self atWrap: i) isNil == nilSkip
				ifFalse: [changes add: i.
					nilSkip := nilSkip not]].

	^ changes ! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 5/2/2004 22:43'!
segmentedSlopes
	"For a collection of floats. Returns the slopes for straight 
	segments between vertices."
	"last slope closes the polygon. Always return same size as 
	self. "
	^ self
		collectWithIndex: [:x :i | (self atWrap: i + 1)
				- x]! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 2/12/2006 23:14'!
slopesClampedWith: knots from: start to: end 
	"Sent to modifiable list of slopes. Fills in the slope values between start
	and end.
	We expect that the parameters meets the assertions in
	self assertSlopesClampedWith: knots from: start to: end."
	"
	
	/* We solve the equation for knots with end conditions: 
	4*b1+b2 = 3(a2 - a0)- b0
	bN2+4*bN1 = 3*(aN-aN1)-bN
	b0, bN are the known starting and ending slopes.
	and inbetween:
	b2+4*b3+b4=3*(a4-a2)
	where a2 is (knots atWrap: index + 1) etc.
	and the b's are the slopes .
	N is the last index (knots size)
	N1 is N-1.
	"
	| gamma delta n1 |
	n1 := self size.
	gamma := Array new: n1.
	delta := Array new: n1.
	gamma at: start put: 0.0.
	(start + 1 to: end - 1)
		do: [:i | gamma atWrap: i put: 1.0 / (4.0
						- (gamma atWrap: i - 1))].
	"gamma atWrap: end put: 1.0 / (4.0
	- (gamma atWrap: end))."
	delta
		at: start
		put: (self at: start).
	(start + 1 to: end - 1)
		do: [:i | delta atWrap: i put: 3.0 * ((knots atWrap: i + 1)
						- (knots atWrap: i - 1))
					- (delta atWrap: i - 1)
					* (gamma atWrap: i)].
	delta
		atWrap: end
		put: (self atWrap: end).
	(start + 1 to: end - 1)
		reverseDo: [:i | self atWrap: i put: (delta atWrap: i)
					- ((gamma atWrap: i)
							* (self atWrap: i + 1)) ]! !

!SequenceableCollection methodsFor: '*Morphic-NewCurves-cubic support' stamp: 'wiz 2/9/2006 01:33'!
slopesWith: knots from: start to: end 
	"Sent to modifiable list of slopes. Fills in the slope values between start
	and end. Start and end slopes can be either clamped or nil. 
	If nil the natural slope for that value will be filled in. 
	We expect that the parameters meets the assertions in
	self assertSlopesWith: knots from: start to: end."
	"
	
	/* We solve the equation for knots with end conditions either known or unknown: 
	4*b1+b2 = 3(a2 - a0)- b0			b0 known
	Or
	2*b0+b1 = 3(a1 - a0) .			b0 == nil
	
	bN2+4*bN1 = 3*(aN-aN2)-bN		bN known
	Or
	bN1+2*bN = 3*(aN-aN1)			bN == nil
	 .
	b0, bN are starting and ending slopes.
	
	
	
	
	and inbetween:
	b2+4*b3+b4=3*(a4-a2)
	where a2 is (knots atWrap: index + 1) etc.
	and the b's are the slopes .
	by using row operations to convert the matrix to upper 
	triangular and then back substitution. 
	"
	| gamma delta n range |
	n := self size.
	gamma := Array new: n.
	delta := Array new: n.
	(self at: start)
		ifNotNil: [
			gamma at: start put: 0.0.
			delta
				at: start
				put: (self at: start).
			range := ( start + 1 to: end - 1 ) .
			] " clamped initial conditions"
		ifNil: [
			gamma at: start put: 2.0 reciprocal.
			delta
				at: start
				put: 3.0 * ((knots atWrap: start + 1)
					- knots at: start ) * (gamma at: start) .
			range := ( start  to: end - 1 ) .
				] "natural initial conditions " .
	(start + 1 to: end - 1)
		do: [:i | gamma atWrap: i put: 1.0 / (4.0
						- (gamma atWrap: i - 1))].
	(start + 1 to: end - 1)
		do: [:i | delta atWrap: i put: 3.0 * ((knots atWrap: i + 1)
						- (knots atWrap: i - 1))
					- (delta atWrap: i - 1)
					* (gamma atWrap: i)].
	(self atWrap: end) 
		ifNil: [ 
			gamma atWrap: end put: 1.0 / (2.0  
										- (gamma atWrap: end - 1 )).
			delta
				atWrap: end
				put: 3.0 * ((knots atWrap: end )
						- knots atWrap: end - 1 ) - (delta at: end -1 )* (gamma atWrap: end) .
			self atWrap: end put: (delta atWrap: end ) .
				] "natural end conditions"
	ifNotNil: [ 
			gamma atWrap: end put: 0.0 .
			delta
				atWrap: end
				put: (self atWrap: end)  .
		
			] "clamped end conditions" .
		
	range
		reverseDo: [:i | self atWrap: i put: 
					(delta atWrap: i)
					- ((gamma atWrap: i)
							* (self atWrap: i + 1)) ] .
	" reciever now contains the filled in slopes."
	^ self ! !

!SequenceableCollection methodsFor: '*Morphic-fliprotate' stamp: 'wiz 4/7/2004 09:31'!
flipRotated: flipIndex 
	"Answer a copy of the receiver with element order indicated by  
	flipIndex."
	"Examples:"
	"'frog' flipRotated: 1"
	"[ :c | (1 to: c size * 2) collect:  
	[ :i | c flipRotated: i ]  
	] value: 'frog'."
	"Lsb of flipIndex indicates whether list is reversed"
	"The flipIndex // 2 gives how much to rotate by after reversing"
	"A good way to think of this is a piece of pie in a pie plate being flip  
	over its leading edge successively."
	"flipIndex > 2 * n are allowed to make it possible to store an array of  
	indexes in an integer."
	| n result src twist |
	n := self size.
	flipIndex \\ (n * 2) = 0
		ifTrue: [^ self].
	"allow for doing nothing"
	result := self species new: n.
	twist := flipIndex // 2 \\ n.
	src := 0.
	(flipIndex even
		ifTrue: [1 + twist to: n + twist]
		ifFalse: [n - 1 - twist to: twist negated by: -1])
		do: [:i | result
				at: (src := src + 1)
				put: (self atWrap: i)].
	^ result! !


!SmartTrashCanMorph methodsFor: 'as yet unclassified' stamp: 'EDC 7/30/2002 16:13'!
acceptDroppingMorph: aMorph event:  evt 
 ActiveWorld submorphs copy do: [:each | (each class  == aMorph class ) ifTrue: [each delete]].

! !

!SmartTrashCanMorph methodsFor: 'initialization' stamp: 'EDC 3/11/2002 05:35'!
initialize
	"Initialize the receiver's graphics, name, and balloon-help"
	super initialize.
	self image: TrashPicOn;
		 offImage: TrashPic;
		 pressedImage: TrashPicOn.
	self setNameTo: 'Trash'.
	self setBalloonText: 'Para eliminar todos los objetos de una misma clase, arrastre uno de ellos dentro del tacho'! !


!Utilities class methodsFor: 'summer97 additions' stamp: 'pk 10/12/2005 07:03'!
chooseFileWithSuffixFromList: aSuffixList withCaption: aCaption
	"Pop up a list of all files in the default directory which have a suffix in the list.  Return #none if there are none; return nil if the user backs out of the menu without making a choice."
	"Utilities chooseFileWithSuffixFromList: #('.gif' '.jpg')"
	| aList aName |
	aList _ OrderedCollection new.
	aSuffixList do:
		[:aSuffix | aList addAll: (FileDirectory default fileNamesMatching: '*', aSuffix)].
	^ aList size > 0
		ifTrue:
			[aName _ (SelectionMenu selections: aList) startUpWithCaption: aCaption.
			aName]
		ifFalse:
			[#none]! !

